/*
 * 分类设置
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class MainColController : BaseController
    {
        public MainColController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 分类设置列表

        /// <summary>
        /// 根据条件查询分类设置列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(Col data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            string Condition = "";
            Condition += "ColName:\"" + data.ColName + "\",";
Condition += "ColEnName:\"" + data.ColEnName + "\",";

            if (!string.IsNullOrEmpty(Condition))
            { 
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询分类设置列表

        /// <summary>
        /// 分类设置列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(Col data, int page = 1, int limit = 30)
        {
            
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            
            Fields.Add("ColName", "2"); //名称
Fields.Add("ColEnName", "2"); //英文名

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("Col", Fields, "Id desc", "0", page, limit, " and Status>-1");
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["RecommendName"] = dic["Recommend"].ToString() == "1" ? "是" : "否";

            }
            return Json(obj);
        }

        #endregion

        #region 增加分类设置

        /// <summary>
        /// 增加或修改分类设置信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            return View();
        }

        #endregion

        #region 增加分类设置

        /// <summary>
        /// 增加或修改分类设置信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(Col data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("ColName", data.ColName); //名称
Fields.Add("ColPicPath", data.ColPicPath); //图标
Fields.Add("ColDetail", data.ColDetail); //简介
Fields.Add("Recommend", data.Recommend); //推荐
Fields.Add("ColEnName", data.ColEnName); //英文名
Fields.Add("Contents", data.Contents); //详细内容
Fields.Add("Url", data.Url); //第三方链接
Fields.Add("ListTemp", data.ListTemp); //列表模板PC
Fields.Add("DetailTemp", data.DetailTemp); //详情模板PC
Fields.Add("ListTempM", data.ListTempM); //列表模板移动
Fields.Add("DetailTempM", data.DetailTempM); //详情模板移动
Fields.Add("ListPageCount", data.ListPageCount); //每页数量
Fields.Add("ClassName", data.ClassName); //class样式名1

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("Col", Fields, 0);
            AddSysLog(data.Id.ToString(), "Col", "add");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 修改分类设置

        /// <summary>
        /// 增加或修改分类设置信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            Col editData = db.Col.FirstOrDefault(m => m.Id == Id) ?? new Col();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改分类设置

        /// <summary>
        /// 增加或修改分类设置信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(Col data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("ColName", data.ColName); //名称
Fields.Add("ColPicPath", data.ColPicPath); //图标
Fields.Add("ColDetail", data.ColDetail); //简介
Fields.Add("Recommend", data.Recommend); //推荐
Fields.Add("ColEnName", data.ColEnName); //英文名
Fields.Add("Contents", data.Contents); //详细内容
Fields.Add("Url", data.Url); //第三方链接
Fields.Add("ListTemp", data.ListTemp); //列表模板PC
Fields.Add("DetailTemp", data.DetailTemp); //详情模板PC
Fields.Add("ListTempM", data.ListTempM); //列表模板移动
Fields.Add("DetailTempM", data.DetailTempM); //详情模板移动
Fields.Add("ListPageCount", data.ListPageCount); //每页数量
Fields.Add("ClassName", data.ClassName); //class样式名1

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("Col", Fields, data.Id);
            AddSysLog(data.Id.ToString(),"Col","update");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 删除分类设置信息

        /// <summary>
        /// 删除分类设置信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"Col","del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("Col", Fields, id);
            }
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"Col","open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("Col", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"Col","close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("Col", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("Col", Sort, Id);
            
            AddSysLog(Id.ToString(), "Col", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count;i++ )
            {
                JsonData dr = list[i];
                
                db.Col.Add(new Col()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    
                });
                db.SaveChanges();
            }
            AddSysLog("0", "Col", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(Col data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("ColName", "2"); //名称
Fields.Add("ColEnName", "2"); //英文名

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("Col", Fields, "Id desc", "0", 1, 20000, "", "ColEnName", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["RecommendName"] = dic["Recommend"].ToString() == "1" ? "是" : "否";

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("ColEnName", "英文名");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "Col", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
